; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	call LCD_ZEILE1				; ZEILE1				
	LDS temp,(adr_TASTE)
	tst temp					; Taste ?				
	breq MENUE_ACTION
	call LCD_CLEAR
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_MENUE_PLUS)	; Taste Menue +			
	breq MENUE_PLUS
	cpi temp,(TASTE_MENUE_MINUS); Taste Menue -			
	breq MENUE_MINUS
	rjmp MENUE_ACTION
;-------------------------------------------------------------------------------
; Menue plus																	
MENUE_PLUS:
	LDS temp1,(adr_MENUE)
	inc temp1
	STS(adr_MENUE),temp1
	rjmp MENUE_ACTION
;-------------------------------------------------------------------------------
; Menue minus																	
MENUE_MINUS:
	LDS temp1,(adr_MENUE)
	tst temp1				; Null ?
	breq MENUE_ACTION
	dec temp1
	STS(adr_MENUE),temp1
	rjmp MENUE_ACTION
;-------------------------------------------------------------------------------
; SD / IDE																		
MENUE_ACTION:
	ldi ZL, LOW(MENUE_SPRUNGMARKE)	; Z		
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	LSL temp	; x2, wegen "jmp (2 Words)"	
	add ZL,temp
	adc ZH,NULL
	IJMP	; SPRUNG nach Z
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	jmp MENUE_HAUPT
	jmp MENUE_PLAY
	jmp MENUE_RECORD
	jmp MENUE_HALL
	jmp MENUE_TESTTON
	jmp MENUE_SEKTOR_VIEW
	jmp MENUE_TEST_READ
	jmp MENUE_TEST_READ_MULTIPLE
	jmp MENUE_TEST_WRITE
	jmp MENUE_TEST_WRITE_MULTIPLE	
	jmp MENUE_TEST
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp ANZEIGE_BEGRUESSUNG
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	STS(adr_MENUE),NULL
	ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_BAUSTELLE:
	call TEXT_BAUSTELLE
	LDS temp1,(adr_MENUE)
	call LCD_ZAHL_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_HAUPT:
	; ZEILE1	
	call LCD_ZEILE1
	call ANZEIGE_ZEIT
	; ZEILE2	
	call LCD_ZEILE2
	call TEXT_SD
	LDS temp1,(adr_SD_CAPACITY_MB0)
	LDS temp2,(adr_SD_CAPACITY_MB1)
	LDS temp3,(adr_SD_CAPACITY_MB2)
	LDS temp4,(adr_SD_CAPACITY_MB3)
	call LCD_ZAHL_TEMP1_2_3_4
	call TEXT_MB
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_PLAY:
	call TEXT_PLAY
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_PLAY_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_PLAY_RUN:
	call TEXT_AKTIVIERT
	call PLAY
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_RECORD:
	call TEXT_RECORD
;-------------------------------------------------------------------------------
MENUE_RECORD_s:
	WDR
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an								
	LDS temp,ADCSRA								; auslesen								
	sbrs temp, ADIF								; ADC-MESSUNG, warten bis ADIF-FLAG gesetzt							
	rjmp MENUE_RECORD_s
;-------------------------------------------------------------------------------
	STS ADCSRA,temp								; ADC-START (ADIF-FLAG lschen durch logisch "1")					
;	LDS temp,ADCL								; zuerst das LOW-Byte					
	LDS temp1,ADCH								; dann das HIGH BYTE	(als Dummy !)	
	call LED_TEMP1								; LEDs					
	STS OCR2A,temp1								; PWM					
	call RAUM_TEMP1								; Raumklang				
	STS OCR2B,temp1								; PWM					
;-------------------------------------------------------------------------------
	sbis (TASTE_A_PIN),(TASTE_A_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	rjmp MENUE_RECORD_w
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	rjmp MENUE_RECORD_w
	sbis (TASTE_C_PIN),(TASTE_C_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	rjmp MENUE_RECORD_w
	sbis (TASTE_D_PIN),(TASTE_D_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	rjmp MENUE_RECORD_w
	sbis (TASTE_E_PIN),(TASTE_E_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	rjmp MENUE_RECORD_w
	sbis (TASTE_F_PIN),(TASTE_F_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	rjmp MENUE_RECORD_w
	rjmp MENUE_RECORD_s
;-------------------------------------------------------------------------------
MENUE_RECORD_w:
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_RECORD_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_RECORD_RUN:
	call TEXT_AKTIVIERT
	call REC
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_HALL:
	call TEXT_HALL
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_HALL_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_HALL_RUN:
	call TEXT_AKTIVIERT
	call HALL
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_TESTTON:
	call TEXT_TESTTON
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_TESTTON_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_TESTTON_RUN:
	call TEXT_AKTIVIERT
	call SAEGEZAHN
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_TEST_READ:
	call TEXT_TEST
	call TEXT_READ
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_TEST_READ_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_TEST_READ_RUN:
	call SD_TEST_READ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SEKTOR_VIEW:
	call TEXT_SEKTOR
	call TEXT_VIEW
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_SEKTOR_VIEW_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SEKTOR_VIEW_RUN:
	call SD_SEKTOR_VIEW
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_TEST_READ_MULTIPLE:
	call TEXT_TEST
	call TEXT_READ
	call TEXT_MULTIPLE
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_TEST_READ_MULTIPLE_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_TEST_READ_MULTIPLE_RUN:
	call SD_TEST_READ_MULTIPLE
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_TEST_WRITE:
	call TEXT_TEST
	call TEXT_WRITE
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_TEST_WRITE_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_TEST_WRITE_RUN:
	call SD_TEST_WRITE
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_TEST_WRITE_MULTIPLE:
	call TEXT_TEST
	call TEXT_WRITE
	call TEXT_MULTIPLE
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_TEST_WRITE_MULTIPLE_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_TEST_WRITE_MULTIPLE_RUN:
	call SD_TEST_WRITE_MULTIPLE
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_TEST:
	call TEXT_TEST
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_TEST_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_TEST_RUN:




ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


