; ##############################################################################
; ##############################################################################
; ##############################################################################
HALL:
	sbic (TASTE_D_PIN),(TASTE_D_PIN_NR)			; springe, wenn BIT(PIN) low
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an   				
	WDR
	LDS temp,ADCSRA								; auslesen					
	sbrs temp, ADIF								; ADC-MESSUNG, warten bis ADIF-FLAG gesetzt							
	rjmp HALL
;-------------------------------------------------------------------------------
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus   			
	STS ADCSRA,temp								; ADC-START (ADIF-FLAG lschen durch logisch "1")					
;	LDS temp,ADCL								; zuerst das LOW-Byte	
	LDS temp1,ADCH								; dann das HIGH BYTE	
	rcall LED_TEMP1								; LEDs					
;-------------------------------------------------------------------------------
	STS OCR2A,temp1								; PWM					
;-------------------------------------------------------------------------------
	sbic (TASTE_D_PIN),(TASTE_D_PIN_NR)			; springe, wenn BIT(PIN) low
	rcall RAUM_TEMP1							; Raumklang				
;-------------------------------------------------------------------------------
	STS OCR2B,temp1								; PWM					
;-------------------------------------------------------------------------------
	sbis (TASTE_F_PIN),(TASTE_F_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	ret
	rjmp HALL
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp/out: temp1																
RAUM_TEMP1:
.equ VERZ =6000		; Verzgerung
	ldi XL,low (adr_BUFFER)	; X			
	ldi XH,high(adr_BUFFER)
	LDS ZL,(adr_ZEIGER_L)	; Z			
	LDS ZH,(adr_ZEIGER_H)
	add XL, ZL				; X+Z		
	adc XH, ZH
	ST X+,temp1				; save X+1	
;-------------------------------------------------------------------------------
	LD temp1,X				; load		
	cpi ZL, LOW (VERZ-1)	; =max ?	
	brne RAUM_w 
	cpi ZH, high(VERZ-1)	; =max ?	
	brne RAUM_w
	ldi XL,low (adr_BUFFER)	; X			
	ldi XH,high(adr_BUFFER)
	LD temp1,X				; load		
;-------------------------------------------------------------------------------
RAUM_w:
	adiw ZL,1				; Z+1		
	cpi ZL, LOW (VERZ)		; =max ?	
	brne RAUM_w1 
	cpi ZH, high(VERZ)		; =max ?	
	brne RAUM_w1 
	STS(adr_ZEIGER_L),NULL	; NULL		
	STS(adr_ZEIGER_H),NULL
	ret
;-------------------------------------------------------------------------------
RAUM_w1:
	STS(adr_ZEIGER_L),ZL
	STS(adr_ZEIGER_H),ZH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Sgezahn																		
SAEGEZAHN:
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	WDR
;-------------------------------------------------------------------------------
	sbis (TASTE_F_PIN),(TASTE_F_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	ret
;-------------------------------------------------------------------------------
	call WAIT_2us
	tst temp9		; Richtung	
	brmi PWM_SZ_n
	inc temp1
	STS OCR2A,temp1								; PWM					
	STS OCR2B,temp1								; PWM					
	cpi temp1,255
	brne SAEGEZAHN
	com temp9		; Richtung	
	rjmp SAEGEZAHN
;-------------------------------------------------------------------------------
PWM_SZ_n:
	dec temp1
	STS OCR2A,temp1								; PWM					
	STS OCR2B,temp1								; PWM					
	tst temp1
	brne SAEGEZAHN
	com temp9		; Richtung	
rjmp SAEGEZAHN
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEMP1:
	cpi temp1,127-15
	brlo ADC_MESSUNG_g
	cpi temp1,127+15
	brsh  ADC_MESSUNG_g
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	rjmp ADC_MESSUNG_w
ADC_MESSUNG_g:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
;-------------------------------------------------------------------------------
ADC_MESSUNG_w:
	cpi temp1,0
	breq ADC_MESSUNG_E
	cpi temp1,255
	breq ADC_MESSUNG_E
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  
	ret
ADC_MESSUNG_E:
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
REC:
	cbi (LED_REC_PORT)  ,(LED_REC_PIN_NR)		; REC  an	
	call SEKTOR_NULL
	call SD_SEKTOR_WRITE_MULTIPLE_START			; START !!!
;-------------------------------------------------------------------------------
REC_s:
	ldi temp,0b11111100				; Start Block Token senden		
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP		
;-------------------------------------------------------------------------------
; 512 Bytes senden																
	ldi ZL,LOW (512)
	ldi ZH,HIGH(512)
;-------------------------------------------------------------------------------
REC_s2:
	WDR
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	LDS temp,ADCSRA								; auslesen					
	sbrs temp, ADIF								; ADC-MESSUNG, warten bis ADIF-FLAG gesetzt							
	rjmp REC_s2
;-------------------------------------------------------------------------------
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	STS ADCSRA,temp								; ADC-START (ADIF-FLAG lschen durch logisch "1")					
;	LDS temp,ADCL								; zuerst das LOW-Byte	
	LDS temp,ADCH								; dann das HIGH BYTE	
	STS OCR2A,temp								; PWM					
	STS OCR2B,temp								; PWM					
	mov temp1,temp
	rcall LED_TEMP1								; LEDs					
;-------------------------------------------------------------------------------
	rcall SPI_TX_RX_TEMP						; INP/OUT: TEMP			
	sbiw ZL,1
	tst ZL
	brne REC_s2
	tst ZH
	brne REC_s2
;-------------------------------------------------------------------------------
	ldi temp1,(0xE5)							; auf  0xE5 warten	
	rcall SPI_WAIT_TEMP1_C
	brcc REC_ERROR								; ERROR				
	ldi temp1,(0xFF)							; auf  0xFF warten	
	cbi (LED_SD_PORT)   ,(LED_SD_PIN_NR)		; SD   an	
	rcall SPI_WAIT_TEMP1_C
	brcc REC_ERROR								; ERROR				
	sbi (LED_SD_PORT)   ,(LED_SD_PIN_NR)		; SD   aus			
;-------------------------------------------------------------------------------
	sbis (TASTE_F_PIN),(TASTE_F_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	rjmp REC_EXIT
	rjmp REC_s
;-------------------------------------------------------------------------------
REC_EXIT:
	call SD_SEKTOR_WRITE_MULTIPLE_STOP			; STOP !!!
	sbi (LED_REC_PORT)  ,(LED_REC_PIN_NR)		; REC  off	
ret
;-------------------------------------------------------------------------------
REC_ERROR:
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PLAY:
	cbi (LED_PLAY_PORT) ,(LED_PLAY_PIN_NR)		; PLAY an	
	call SEKTOR_NULL
	call SD_SEKTOR_READ_MULTIPLE_START			; START		
;-------------------------------------------------------------------------------
PLAY_s:
	ldi temp1,(0xFE)							; auf  0xFE warten	
	rcall SPI_WAIT_TEMP1_C
	brcc PLAY_ERROR
;-------------------------------------------------------------------------------
; 512 Bytes read																
	ldi ZL,LOW (512)
	ldi ZH,HIGH(512)
;-------------------------------------------------------------------------------
PLAY_s2:
	WDR
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an								
	LDS temp,ADCSRA								; auslesen								
	sbrs temp, ADIF								; ADC-MESSUNG, warten bis ADIF-FLAG gesetzt							
	rjmp PLAY_s2
	STS ADCSRA,temp								; ADC-START (ADIF-FLAG lschen durch logisch "1")					
;	LDS temp,ADCL								; zuerst das LOW-Byte					
	LDS temp,ADCH								; dann das HIGH BYTE	(als Dummy !)	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus								
;-------------------------------------------------------------------------------
	rcall SPI_RX_TEMP							; OUT: temp				
	mov temp1,temp
	rcall LED_TEMP1								; LEDs					
	STS OCR2A,temp1								; PWM					
;-------------------------------------------------------------------------------
	push ZL
	push ZH
	sbic (TASTE_D_PIN),(TASTE_D_PIN_NR)			; springe, wenn BIT(PIN) low
	rcall RAUM_TEMP1							; Raumklang				
	pop ZH
	pop ZL
;-------------------------------------------------------------------------------
	STS OCR2B,temp1								; PWM					
	sbiw ZL,1
	tst ZL
	brne PLAY_s2
	tst ZH
	brne PLAY_s2
;-------------------------------------------------------------------------------
	sbis (TASTE_F_PIN),(TASTE_F_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	rjmp PLAY_EXIT
;-------------------------------------------------------------------------------
	rjmp PLAY_s
;-------------------------------------------------------------------------------
PLAY_EXIT:
	call SD_SEKTOR_READ_MULTIPLE_STOP			; STOP		
	sbi (LED_PLAY_PORT) ,(LED_PLAY_PIN_NR)		; PLAY aus	
ret
;-------------------------------------------------------------------------------
PLAY_ERROR:
	cbi (LED_SD_PORT)   ,(LED_SD_PIN_NR)		; SD   an	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
