; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_ABFRAGE:
	rcall TASTEN_PINS_TEMP
	STS(adr_TASTE),temp						; save		
;-------------------------------------------------------------------------------
; TASTE ?																		
	tst temp							
	brne TASTE_w
	ret
;-------------------------------------------------------------------------------
TASTE_w:
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  aus	
	sbi (LED_GELB_PORT)  ,(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	cpi temp,(TASTE_MINUS)+(TASTE_PLUS)			; Reset ?	
	breq TASTE_w1
	ret
;-------------------------------------------------------------------------------
; Reset																			
TASTE_w1:
	CLI
	call LCD_CLEAR
	call TEXT_RESET
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
	cbi (LED_REC_PORT)  ,(LED_REC_PIN_NR)		; REC  an	
	cbi (LED_PLAY_PORT) ,(LED_PLAY_PIN_NR)		; PLAY an	
	call WAIT_1s
	jmp RESET
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_PINS_TEMP:
	WDR
	clr temp
	cbi (TASTE_A_DDR),(TASTE_A_PIN_NR)	; auf Eingang					
	cbi (TASTE_B_DDR),(TASTE_B_PIN_NR)
	cbi (TASTE_C_DDR),(TASTE_C_PIN_NR)
	cbi (TASTE_D_DDR),(TASTE_D_PIN_NR)
	cbi (TASTE_E_DDR),(TASTE_E_PIN_NR)
	cbi (TASTE_F_DDR),(TASTE_F_PIN_NR)
;-------------------------------------------------------------------------------
	sbi (TASTE_A_PORT),(TASTE_A_PIN_NR)	; Pull-Up on					
	sbi (TASTE_B_PORT),(TASTE_B_PIN_NR)
	sbi (TASTE_C_PORT),(TASTE_C_PIN_NR)
	sbi (TASTE_D_PORT),(TASTE_D_PIN_NR)
	sbi (TASTE_E_PORT),(TASTE_E_PIN_NR)
	sbi (TASTE_F_PORT),(TASTE_F_PIN_NR)
	call WAIT_10us
;-------------------------------------------------------------------------------
	; Taste "A"gedrckt ?		
	sbis (TASTE_A_PIN),(TASTE_A_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(TASTE_A)
	; Taste "B"gedrckt ?		
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(TASTE_B)
	; Taste "C"gedrckt ?		
	sbis (TASTE_C_PIN),(TASTE_C_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(TASTE_C)
	; Taste "D"gedrckt ?		
	sbis (TASTE_D_PIN),(TASTE_D_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(TASTE_D)
;-------------------------------------------------------------------------------
;	sbi (TASTE_A_DDR),(TASTE_A_PIN_NR)	; auf AUSGANG					
;	sbi (TASTE_B_DDR),(TASTE_B_PIN_NR)
;	sbi (TASTE_C_DDR),(TASTE_C_PIN_NR)
;	sbi (TASTE_D_DDR),(TASTE_D_PIN_NR)
;-------------------------------------------------------------------------------
	call WAIT_10us
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OUT: CARRY																	
TASTE_PLUS_C:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_PLUS)
	breq TASTE_PLUS_RUN
	CLC ;Clear Carry
	ret
;-------------------------------------------------------------------------------
TASTE_PLUS_RUN:
	SEC ;Set Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OUT: CARRY																	
TASTE_MINUS_C:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_MINUS)
	breq TASTE_MINUS_RUN
	CLC ;Clear Carry
	ret
;-------------------------------------------------------------------------------
TASTE_MINUS_RUN:
	SEC ;Set Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_PAUSE:
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTATUR_PAUSE_w
	jmp WAIT_100ms
;-------------------------------------------------------------------------------
TASTATUR_PAUSE_w:
	jmp WAIT_200ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_WAIT:
	call WAIT_500ms
;-------------------------------------------------------------------------------
TASTEN_WAIT_s:
	call WAIT_100ms
	call TASTEN_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTEN_WAIT_s
;-------------------------------------------------------------------------------
TASTEN_WAIT_s1:
	call WAIT_100ms
	call TASTEN_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	breq TASTEN_WAIT_s1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "wirklich ?"																	
; OUT: Carry																	
TASTE_FRAGE_WIRKLICH_C:
	call LCD_CLEAR
	call TEXT_WIRKLICH
;-------------------------------------------------------------------------------
TASTE_FRAGE_s:
	call TASTEN_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTE_FRAGE_s
;-------------------------------------------------------------------------------
	call LCD_ZEILE3			; ZEILE
	call TEXT_TASTE
	call LCD_GAENSEFUESSCHEN
	call LCD_MINUS
	call LCD_GAENSEFUESSCHEN
	call LCD_SPACE
	call LCD_ISTGLEICH
	call LCD_O
	call LCD_K
	call WAIT_500ms
;-------------------------------------------------------------------------------
TASTE_FRAGE_s1:
	call TASTEN_ABFRAGE
	call TASTE_MINUS_C	; Taste '-' = Ja	
	brcs TASTE_FRAGE_JA
	LDS temp,(adr_TASTE)
	tst temp
	breq TASTE_FRAGE_s1
;-------------------------------------------------------------------------------
TASTE_FRAGE_NEIN:
	call LCD_CLEAR
	call TEXT_ABBRUCH
	call WAIT_1s
	CLC ;Clear Carry
	ret
TASTE_FRAGE_JA:
	call LCD_CLEAR
	SEC ;Set Carry	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
