;													
; 300ms Echo ATmega1284P							
; Bernhard.Erfurt@gmx.de							
; https://www.mikrocontroller.net/topic/474376#new	
; 05.2019											
;													

;												
; LED blinken:									
; ROT: 				Interrupt Error				
; ROT+GELB:			Watchdog Error				
; ROT+GELB+GRN:	Programm-Check Error		
;												

; ATmega1284P 									
.include "m1284pdef.inc"
; KONSTANTEN									
.equ TAKT							=22000000	; 22 MHz			

.equ ERROR_SD_STATUS				= 0xC0

.equ ERROR_SD_READ					= 0xE0	; schwerer Fehler	
.equ ERROR_SD_READ_MULTIPLE			= 0xEF	; schwerer Fehler	

.equ ERROR_SD_WRITE0				= 0xF0	; schwerer Fehler	
.equ ERROR_SD_WRITE1				= 0xF1	; schwerer Fehler	
.equ ERROR_SD_WRITE2				= 0xF2	; schwerer Fehler	
.equ ERROR_SD_WRITE_MULTIPLE		= 0xEF	; schwerer Fehler


; REGISTER										
.def ERROR		= R7

.def SEKTOR0	= R9
.def SEKTOR1	= R10
.def SEKTOR2	= R11
.def SEKTOR3	= R12

.def NULL 		= R13
.def EINS 		= R14
.def VOLL		= R15

.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25

; LED-GRN										
.equ LED_GRUEN_PIN_NR		= 0
.equ LED_GRUEN_DDR			= DDRB
.equ LED_GRUEN_PORT			= PORTB
; LED-GELB										
.equ LED_GELB_PIN_NR		= 1
.equ LED_GELB_DDR			= DDRB
.equ LED_GELB_PORT			= PORTB
; LED-ROT										
.equ LED_ROT_PIN_NR			= 2
.equ LED_ROT_DDR			= DDRB
.equ LED_ROT_PORT			= PORTB
; LED-PLAY										
.equ LED_PLAY_PIN_NR		= 1
.equ LED_PLAY_DDR			= DDRA
.equ LED_PLAY_PORT			= PORTA
; LED-RECORD										
.equ LED_REC_PIN_NR			= 2
.equ LED_REC_DDR			= DDRA
.equ LED_REC_PORT			= PORTA
; LED-SD										
.equ LED_SD_PIN_NR			= 3
.equ LED_SD_DDR				= DDRA
.equ LED_SD_PORT			= PORTA


; TASTE "A"										
.equ TASTE_A_PIN_NR			= 0
.equ TASTE_A_PIN			= PIND
.equ TASTE_A_DDR			= DDRD
.equ TASTE_A_PORT			= PORTD
.equ TASTE_A				= 1
.equ TASTE_MENUE_MINUS		= 1
; TASTE "B"										
.equ TASTE_B_PIN_NR			= 1
.equ TASTE_B_PIN			= PIND
.equ TASTE_B_DDR			= DDRD
.equ TASTE_B_PORT			= PORTD
.equ TASTE_B				= 2
.equ TASTE_MENUE_PLUS		= 2
; TASTE "C"										
.equ TASTE_C_PIN_NR			= 2
.equ TASTE_C_PIN			= PIND
.equ TASTE_C_DDR			= DDRD
.equ TASTE_C_PORT			= PORTD
.equ TASTE_C				= 4
.equ TASTE_MINUS			= 4
; TASTE "D"										
.equ TASTE_D_PIN_NR			= 3
.equ TASTE_D_PIN			= PIND
.equ TASTE_D_DDR			= DDRD
.equ TASTE_D_PORT			= PORTD
.equ TASTE_D				= 8
.equ TASTE_PLUS				= 8
; TASTE "E"										
.equ TASTE_E_PIN_NR			= 4
.equ TASTE_E_PIN			= PIND
.equ TASTE_E_DDR			= DDRD
.equ TASTE_E_PORT			= PORTD
; TASTE "F"										
.equ TASTE_F_PIN_NR			= 5
.equ TASTE_F_PIN			= PIND
.equ TASTE_F_DDR			= DDRD
.equ TASTE_F_PORT			= PORTD



; LCD (DATA)									
.equ LCD_DATA0_DDR			= DDRC
.equ LCD_DATA1_DDR			= DDRC
.equ LCD_DATA2_DDR			= DDRC
.equ LCD_DATA3_DDR			= DDRC
.equ LCD_DATA0_PORT			= PORTC
.equ LCD_DATA1_PORT			= PORTC
.equ LCD_DATA2_PORT			= PORTC
.equ LCD_DATA3_PORT			= PORTC
.equ LCD_DATA0				= 2
.equ LCD_DATA1				= 3
.equ LCD_DATA2				= 4
.equ LCD_DATA3				= 5
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_DDR				= DDRC
.equ LCD_RS_PORT			= PORTC
.equ LCD_RS					= 6
; LCD_ENABLE									
.equ LCD_EN_DDR				= DDRC
.equ LCD_EN_PORT			= PORTC
.equ LCD_EN					= 7


; SPI-CS										
.equ SPI_CS_PIN_NR			= 4
.equ SPI_CS_DDR				= DDRB
.equ SPI_CS_PORT			= PORTB
; SPI-MOSI										
.equ SPI_MOSI_PIN_NR		= 5
.equ SPI_MOSI_DDR			= DDRB
.equ SPI_MOSI_PORT			= PORTB
; SPI-MISO										
.equ SPI_MISO_PIN_NR		= 6
.equ SPI_MISO_DDR			= DDRB
.equ SPI_MISO_PORT			= PORTB
; SPI-SCK										
.equ SPI_SCK_PIN_NR			= 7
.equ SPI_SCK_DDR			= DDRB
.equ SPI_SCK_PORT			= PORTB





; SRAM-BELEGUNG Adr:0x0100-0x40FF(256-16.639=16383)					
.equ adr_DATEN						=SRAM_START+0		; 0x0100 START Adresse 		

.equ adr_MENUE						=SRAM_START+41
.equ adr_TASTE						=SRAM_START+42



.equ adr_ss_VT						=SRAM_START+60		
.equ adr_ss							=SRAM_START+61		; Sekunden					
.equ adr_ss_OLD						=SRAM_START+62
.equ adr_mm							=SRAM_START+63		; Minuten					
.equ adr_hh							=SRAM_START+64		; Stunden					
.equ adr_TAG						=SRAM_START+65		; TAG		

.equ adr_ZUFALLSZAHL				=SRAM_START+80
.equ adr_DUMMY						=SRAM_START+81		; DUMMY				
.equ adr_DUMMY1						=SRAM_START+82		; DUMMY				

.equ adr_ZAEHLER0					=SRAM_START+96
.equ adr_ZAEHLER1					=SRAM_START+97
.equ adr_ZAEHLER2					=SRAM_START+98
.equ adr_ZAEHLER3					=SRAM_START+99

.equ adr_ZEIGER_L					=SRAM_START+100
.equ adr_ZEIGER_H					=SRAM_START+101

.equ adr_SD_PNM1					= SRAM_START+150		; Product name PNM				
.equ adr_SD_PNM2					= SRAM_START+151
.equ adr_SD_PNM3					= SRAM_START+152
.equ adr_SD_PNM4					= SRAM_START+153
.equ adr_SD_PNM5					= SRAM_START+154
.equ adr_SD_MDT_L					= SRAM_START+155		; Manufacturing date
.equ adr_SD_MDT_H					= SRAM_START+156
.equ adr_SD_PSN0					= SRAM_START+157		; Product serial number			
.equ adr_SD_PSN1					= SRAM_START+158
.equ adr_SD_PSN2					= SRAM_START+159
.equ adr_SD_PSN3					= SRAM_START+160

.equ adr_SD_SEKTOR_MAX0				=SRAM_START+200		; Secector max		
.equ adr_SD_SEKTOR_MAX1				=SRAM_START+201		; Secector max		
.equ adr_SD_SEKTOR_MAX2				=SRAM_START+202		; Secector max		
.equ adr_SD_SEKTOR_MAX3				=SRAM_START+203		; Secector max		

.equ adr_SD_CAPACITY_MB0			=SRAM_START+204		; Capacity in MB	
.equ adr_SD_CAPACITY_MB1			=SRAM_START+205		; Capacity in MB	
.equ adr_SD_CAPACITY_MB2			=SRAM_START+206		; Capacity in MB	
.equ adr_SD_CAPACITY_MB3			=SRAM_START+207		; Capacity in MB	

.equ adr_SD_SDHC_AKTIV				= SRAM_START+210	; 0=SDSC 1=SDHC		
.equ adr_SD_CSD_READ_BL_LEN			= SRAM_START+211 	; Register CSD =>READ_BL_LEN	
.equ adr_SD_CSD_C_SIZE_0			= SRAM_START+212	; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_1			= SRAM_START+213	; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_MULT			= SRAM_START+214 	; Register CSD =>C_SIZE_MULT	
.equ adr_SD_CSD_MULT_L				= SRAM_START+215
.equ adr_SD_CSD_MULT_H				= SRAM_START+216



.equ adr_DATA						=SRAM_START+1000	; SD-DATA					

.equ adr_BUFFER						=SRAM_START+2000

.equ adr_SRAM_CHECK					=SRAM_START+16300	; SRAM CHECK muss immer "S" sein	



.cseg							;Beginn eines Code-Segmentes
.org 0							;Startadresse=0				
.org 0x0000 rjmp RESET 			 ; Reset									
.org 0x0002 rjmp INTERRUPT_ERROR ;rjmp INT0 ; IRQ0							
.org 0x0004 rjmp INTERRUPT_ERROR ;rjmp INT1 ; IRQ1							
.org 0x0006 rjmp INTERRUPT_ERROR ;rjmp INT2 ; IRQ2							
.org 0x0008 rjmp INTERRUPT_ERROR ;rjmp PCINT0 ; PCINT0						
.org 0x000A rjmp INTERRUPT_ERROR ;rjmp PCINT1 ; PCINT1						
.org 0x000C rjmp INTERRUPT_ERROR ;rjmp PCINT2 ; PCINT2						
.org 0x000E rjmp INTERRUPT_ERROR ;rjmp PCINT3 ; PCINT3						
.org 0x0010 jmp WDT 			 ; Watchdog Timeout			
.org 0x0012 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPA ; Timer2 CompareA			
.org 0x0014 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPB ; Timer2 CompareB			
.org 0x0016 rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF 	; Timer2 Overflow		
.org 0x0018 rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT ; Timer1 Capture			
.org 0x001A rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPA ; Timer1 CompareA			
.org 0x001C rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB			
.org 0x001E rjmp INTERRUPT_ERROR ;rjmp TIM1_OVF 	; Timer1 Overflow		
.org 0x0020 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPA ; Timer0 CompareA			
.org 0x0022 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPB ; Timer0 CompareB			
.org 0x0024 rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF 	; Timer0 Overflow		
.org 0x0026 rjmp INTERRUPT_ERROR ;rjmp SPI_STC ; SPI Transfer Complete		
.org 0x0028 rjmp INTERRUPT_ERROR ;rjmp USART0_RXC ; USART0 RX Complete		
.org 0x002A rjmp INTERRUPT_ERROR ;rjmp USART0_UDRE ; USART0,UDR Empty		
.org 0x002C rjmp INTERRUPT_ERROR ;rjmp USART0_TXC ; USART0 TX Complete		
.org 0x002E rjmp INTERRUPT_ERROR ;rjmp ANA_COMP ; Analog Comparator			
.org 0x0030 rjmp INTERRUPT_ERROR ;rjmp ADC ; ADC Conversion Complete		
.org 0x0032 rjmp INTERRUPT_ERROR ;rjmp EE_RDY ; EEPROM Ready				
.org 0x0034 rjmp INTERRUPT_ERROR ;rjmp TWI ; 2-wire Serial					
.org 0x0036 rjmp INTERRUPT_ERROR ;rjmp SPM_RDY ; SPM Ready					
.org 0x0038 rjmp INTERRUPT_ERROR ;rjmp USART1_RXC ; USART1 RX Complete		
.org 0x003A rjmp INTERRUPT_ERROR ;rjmp USART1_UDRE ; USART1,UDR Empty		
.org 0x003C rjmp INTERRUPT_ERROR ;rjmp USART1_TXC ; USART1 TX Complete		
.org 0x003E rjmp INTERRUPT_ERROR ;rjmp TIM3_CAPT ; Timer3 Capture			
.org 0x0040 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPA ; Timer3 CompareA			
.org 0x0042 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPB ; Timer3 CompareB			
.org 0x0044 rjmp TIM3_OVF 		 ; Timer3 Overflow		
; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	call wait_100ms
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  aus	
	sbi (LED_GELB_PORT)  ,(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	call wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)				; STACK initialisieren	
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	call SRAM_CLEAR						; SRAM_CLEAR			
	call PORT_CLEAR						; Ports auf EINGANG		
	call STARTWERTE						; Startwerte			
	call WDR_INITIALISIERUNG			; WDR					
	call LED_INITIALISIERUNG			; LED_INITIALISIERUNG	
;	call TIMER0_INITIALISIERUNG_PWM8	; PWM					
;	call TIMER1_INITIALISIERUNG_PWM16	; PWM					
	call TIMER2_INITIALISIERUNG_PWM8	; PWM					
;	call TIMER3_INITIALISIERUNG_PWM16	; PWM					
	call TIMER3_INITIALISIERUNG_UHR		; Uhr					
	call ADC_INITIALISIERUNG			; ADC					
	call LCD_INITIALISIERUNG			; LCD					
	call SPI_INITIALISIERUNG			; SPI					
	call PROGRAMM_CHECK					; Check					
	sei									; Interrupts enable		
;-------------------------------------------------------------------------------
	call ANZEIGE_BEGRUESSUNG
	call WAIT_200ms
	call SD_INITIALISIERUNG
	call LCD_CLEAR
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	call TASTEN_ABFRAGE
	call MENUE
	call SD_CHECK
	call PROGRAMM_CHECK					; Check					
	call TASTEN_PAUSE
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "TIMER.asm"			; PWM			
.include "ADC.asm"				; ADC			
.include "SOUND.asm"			; Sound			
.include "SPI.asm"				; SPI			
.include "SD.asm"				; SD			
.include "SD_SONSTIGES.asm"		; SD			
.include "TASTEN.asm"			; Tasten		
.include "SONSTIGES.asm"		; sonstiges		
.include "LCD.asm"				; LCD			
.include "LCD_ANZEIGE.asm"		; LCD			
.include "LCD_TEXTE.asm"		; LCD			
.include "MENUE.asm"			; Menue			
.include "WAIT.asm"				; wait			


TEXT_LCD_BEGRUESSUNG_1:
.db "ATmega1284p",0
TEXT_LCD_BEGRUESSUNG_2:
.db "05/2019",0
